%---------------------------
%discrete event simulation
%the time is counted in microseconds 
%1 second=1000  milliseconds=10^6 microseconds
%NSFNet
%EBSL with deflection
%---------------------------
clear all;
format long;
propagation_speed=3*1e8/1e6;
%propagation_speed=1e20;
switching_delay=0; %usually smaller than 1, so ignore
offset_time=10; %micorseconds
packet_length=1250*8; %bits

%average burst length=2.5MB
packet_no_ave=250;
transmission_speed=10*1e9/1e6; %bit/micros

Simulation=3e5;
node=14;
L=42;
OD_no=node*(node-1);
C=50;
D_max=3;


[OD_path,deflect_to]=calculate_routing_table_nsf_add_deflection3();
link_length=[260 260 252 252 380 380 324 324 868 868 416  416 272 272 248 248 292 292 212  212 224 224 704 704 1036 1036 1140 1140 408 408 536 536 668 668 684 684 664 664 352 352 752 752]*1000;


Traffic=[1 2];

link_b=zeros(length(Traffic),L);
goodput_s=zeros(length(Traffic),OD_no);
EU_s=zeros(length(Traffic),L);
for traf=1:length(Traffic)
    Simulation=5e5;

    lambda=ones(1,OD_no)*Traffic(traf);  %busrts/micosecond
    
    %propagation_daley_link=link_length./propagation_speed;
    buffer=0;  % no buffer at the core node
    link_use=zeros(L,C,1+buffer,13);%layer-1 1-occupy or not; 2-OD_pair; 3-path no 4- hop no; 5-priority_no ; 6-finish time 7-reservation no 
    %8-burst length (no. of packets) 9-no of left bits 10-part_no 11-deflection_no 12-first bit  13-last bit ;
    buffer2=10000;
    reservation_queque=zeros(OD_no,buffer2,12);%1-occupy or not 2-path_no 3-next hop no 4 next hop arrival time 5-reservation_no 6-burst length (no. of packets) 
    %7-no of left bits 8-part_no 9-deflection_no  10 priority_no 11-first bit 12-last bit;
    Burst_no_of_part=zeros(1,Simulation);
    
    block=zeros(1,OD_no);
    departure=zeros(1,OD_no);
    traffic=lambda*(packet_length*packet_no_ave/transmission_speed);
    link_block=zeros(1,L);
    link_departure=zeros(1,L);
    good_calls=zeros(Simulation,20,22*3+1); %1-finish or not 2- path no. 3- arrival time 4- deparutre time; 5,8,11,14,17==2; 6,9,12,15,18=3; 7,10,13,16,19==4;
    
   %receive_table=zeros(Simulation,packet_no_ave*10);
    
    
    arrivelIntervalTime_control(1:Simulation) = exprnd(1/(sum(lambda)),[1,Simulation]);  % arrival of the control packets, follow possion distribution
    nextNewArrivalTime=arrivelIntervalTime_control(1)+offset_time;
    rd=rand();
%     part_arrival=lambda(1);
%     finish=0;
%     count=1;
%     while (finish==0)
%         if rd<part_arrival/sum(lambda)
%             OD_pair=count;
%             finish=1;
%         else
%             count=count+1;
%             part_arrival=part_arrival+lambda(count);
%         end
%     end
%since all the arrival rate is the same, calculate the OD_pair in a simpler way
    OD_pair=floor(rd*OD_no+1);
    packet_no=floor(exprnd(packet_no_ave,1));
    
    
    path_length=length(find(OD_path(OD_pair,1,:)>0));  %find the length of the path;
    % calculate the happen time of the next event of different kinds
    nextArrivalTime=nextNewArrivalTime+offset_time+link_length(OD_path(OD_pair,1,1))/propagation_speed; % time of the burst arrival the next hop
    nextBurst_come=nextArrivalTime;  %the time of the next burst arriving to a hop (not a new arrival)
    nextBurstEvent_finish=nextNewArrivalTime+packet_no*packet_length/transmission_speed;  %the time of the burst finish serving in this hop
    
    %record in the table
    if(path_length>1)    % there is the second hop, record the header
    reservation_queque(OD_pair,1,:)=[1 1 2 nextArrivalTime 1 packet_no packet_no*packet_length 1 0 path_length-1 1 packet_no*packet_length];
    end
    link_use(OD_path(OD_pair,1,1),1,1,:)=[1 OD_pair 1 1 path_length-1 nextBurstEvent_finish 1 packet_no packet_no*packet_length 1 0 1 packet_no*packet_length];
    reservation_count=1;
    good_calls(reservation_count,1,2)=OD_path(OD_pair,1,1);
    good_calls(reservation_count,1,3)=nextNewArrivalTime;
    Burst_no_of_part(reservation_count)=1;
    state_probability=zeros(L,C+1);
    %segBurst_com=1e20;
    
    
    %four kinds of event (1) the first reservation of a new control packet (2) a new reservation finish (not in the first hop) (3) a burst comes into a %%hop (4) a burst finish serving in a hop
    
    arrival=1;
    nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
    packet_arrival=zeros(1,OD_no);
    arrival_path=zeros(OD_no,50);
    departure_path=zeros(OD_no,50);
    while arrival<Simulation-1
        
        if nextNewArrivalTime<=nextBurst_come && nextNewArrivalTime<=nextBurstEvent_finish
            %a new control packet finish reserve the resource ( reserving resources ), a new call comes into the network
            %generate the OD no, path length of the new control packet and the arrival time of the new burst
            
            for iii=1:L
                x=sum(link_use(iii,:,1,1));
                state_probability(iii,x+1)=state_probability(iii,x+1)+1;
            end
            
            %generate the basic parameter for this new arrival burst
            rd=rand();
            OD_pair=floor(rd*OD_no+1);
            packet_no=floor(exprnd(packet_no_ave,1)); %generate the number of packets of the burst
            
            
            if (arrival>10000)
            packet_arrival(OD_pair)=packet_arrival(OD_pair)+packet_no;
            end
            
            
            burst_finish_time=nextNewArrivalTime+packet_no*packet_length/transmission_speed;
            nextHopArrivalTime=nextNewArrivalTime+offset_time+link_length(OD_path(OD_pair,1,1))/propagation_speed;
            path_length=length(find(OD_path(OD_pair,1,:)>0));
            
            %find free path
            occupy=link_use(OD_path(OD_pair,1,1),:,1,1);
            isFree=find(occupy(:)==0);
            if arrival>10000
            arrival_path(OD_pair,1)=arrival_path(OD_pair,1)+packet_no;
            end
            if isempty(isFree)
                %no free channel,find if can kick
                link_no=OD_path(OD_pair,1,1);
               xx=find(link_use(link_no,:,1,5)>=path_length);
               if isempty(xx)
                    %no free slots, deflect the butst
                    link_block(link_no)=link_block(link_no)+packet_no;
                    burst_priority=100;
                    de_time=0;
                    path_no=1;
                    while de_time<D_max
                        de_time=de_time+1;
%                         if de_time==D_max
%                             %can not overflow, block
%                             %block(OD_pair)=block(OD_pair)+packet_no;
%                         else
                            path_no=deflect_to(OD_pair,path_no,1);
                            if path_no==0
                                de_time=100; %cannot deflect, block the call
                                
                                %block(OD_pair)=block(OD_pair)+packet_no;
                            else
                                if arrival>10000
                                    arrival_path(OD_pair,path_no)=arrival_path(OD_pair,path_no)+packet_no;
                                end
                                occupy1=link_use(OD_path(OD_pair,path_no,1),:,1,1);
                                isFree1=find(occupy1(:)==0);
                                if isempty(isFree1)
                                    link_block(OD_path(OD_pair,path_no,1))=link_block(OD_path(OD_pair,path_no,1))+packet_no;
                                    
                                else
                                    
                                    reservation_count=reservation_count+1;
                                    Burst_no_of_part(reservation_count)=1;
                                    good_calls(reservation_count,1,2)=OD_path(OD_pair,path_no,1);
                                    good_calls(reservation_count,1,3)=nextNewArrivalTime;
                                    channel=isFree1(floor(rand()*length(isFree1)+1));  %random select a free channel
                                    
                                    path_length=length(find(OD_path(OD_pair,path_no,:)>0));
                                    link_use(OD_path(OD_pair,path_no,1),channel,1,:)=[1 OD_pair path_no 1 100 burst_finish_time  reservation_count packet_no packet_no*packet_length 1 de_time 1 packet_no*packet_length];
                                    
                                    %update reservation_queque
                                    slot=min(find(reservation_queque(OD_pair,:,1)==0));
                                    nextHopArrivalTime=nextNewArrivalTime+offset_time+link_length(OD_path(OD_pair,path_no,1))/propagation_speed;
                                    if (path_length>1)
                                        reservation_queque(OD_pair,slot,:)=[1 path_no 2  nextHopArrivalTime reservation_count packet_no packet_no*packet_length 1 de_time 100 1 packet_no*packet_length];
                                        if nextBurst_come>nextHopArrivalTime
                                            nextBurst_come=nextHopArrivalTime;
                                        end
                                    end
                                    if nextBurstEvent_finish>burst_finish_time
                                        nextBurstEvent_finish=burst_finish_time;
                                    end
                                    
                                    %finish
                                    de_time=100;
                                end
                            end
                           
                        %end
                    end
                    if de_time==D_max
                        % block the new burst
                    end
               else      
                    %the call finds a channel with lower priority call serves,
                    %so the new call kicks the old one
                    max_priority=max(link_use(link_no,xx,1,5));
                    xxx=find(link_use(link_no,:,1,5)==max_priority);
                    
                    %-----check
                    if max_priority<path_length
                        nnn=1
                    end
                    %------
                    channel=xxx(floor(rand()*length(xxx)+1));
                    template=link_use(link_no,channel,1,:);
                    %fit the new call
                    reservation_count=reservation_count+1;
                    Burst_no_of_part(reservation_count)=1;
                    link_use(link_no,channel,1,:)=[1 OD_pair 1 1 path_length-1 burst_finish_time  reservation_count packet_no packet_no*packet_length 1 0 1 packet_no*packet_length];
                    %update reservation_queque of the new call
                    slot=min(find(reservation_queque(OD_pair,:,1)==0));
                    %update good_calls
                    good_calls(reservation_count,1,2)=OD_path(OD_pair,1,1);
                    good_calls(reservation_count,1,3)=nextNewArrivalTime;
                    if (path_length>1)
                        reservation_queque(OD_pair,slot,:)=[1 1 2  nextHopArrivalTime reservation_count packet_no packet_no*packet_length 1 0 path_length-1 1 packet_no*packet_length];
                        if nextBurst_come>nextHopArrivalTime
                            nextBurst_come=nextHopArrivalTime;
                        end
                    end
                    % update the next event time of different kinds
                    if nextBurstEvent_finish>burst_finish_time
                        nextBurstEvent_finish=burst_finish_time;
                    end
                    % deal with the segmented burst the rest of the burst will deflect and the reservation_queque and the link_use need to update
                    seg_reservation_no=template(7);
                    
                    seg_path_no=template(3);
                    seg_de_no=template(11);
                    seg_part_no=template(10);
                    seg_hop_no=template(4);
                    seg_finish_time=template(6);
                    seg_bits_seg=round((seg_finish_time-nextNewArrivalTime)*transmission_speed);
                    seg_bits_left=template(9)-seg_bits_seg;
                    seg_last_bit=template(13);
                    seg_new_first_bit=seg_bits_left+1;
                    seg_packet_no=template(8);
                    seg_OD=template(2);
                    
                    %deal with the bits left
                    slot=find(reservation_queque(seg_OD,:,5)==seg_reservation_no & reservation_queque(seg_OD,:,8)==seg_part_no);
                    
                    link_block(OD_path(OD_pair,1,1))=link_block(OD_path(OD_pair,1,1))+seg_bits_seg;
                    link_departure(OD_path(OD_pair,1,1))=link_departure(OD_path(OD_pair,1,1))+seg_bits_left;
                    if (reservation_queque(seg_OD,slot,7)>seg_bits_left)
                        reservation_queque(seg_OD,slot,7)=seg_bits_left;
                        reservation_queque(seg_OD,slot,12)=seg_new_first_bit-1;
                    end
                    %need to update the link_use
                    calls=find(link_use(:,:,:,7)==seg_reservation_no &link_use(:,:,:,10)==seg_part_no);
                    seg_place=1; % always 1
                    seg_channel=floor((calls-1)/L+1);
                    seg_L=calls-(seg_channel-1)*L;
                    %the bits on the hop before this hop just let it finish, do not need to update,
                    for i=1:length(calls)
                        if link_use(seg_L(i),seg_channel(i),1,4)>template(4) && link_use(seg_L(i),seg_channel(i),1,9)>seg_bits_left
                            %update the information of the hops after this seg hop
                            time_save=(link_use(seg_L(i),seg_channel(i),1,9)-seg_bits_left)/transmission_speed;
                            link_use(seg_L(i),seg_channel(i),1,9)=seg_bits_left;
                            finish_time_new=link_use(seg_L(i),seg_channel(i),1,6)-time_save;
                            link_use(seg_L(i),seg_channel(i),1,6)=finish_time_new;
                            link_use(seg_L(i),seg_channel(i),1,13)=seg_new_first_bit-1;
                            if nextBurstEvent_finish>finish_time_new
                                nextBurstEvent_finish=finish_time_new;
                            end
                        end
                    end
                    
                    
                    %deal with the segmented part
                    priority_no=100;
                    if seg_de_no==D_max
                        %can not deflect again, drop
                    else
                        %deflected
                        de_path_no=seg_path_no;
                        seg_de_no=seg_de_no+1;
                        while seg_de_no<=D_max
                                de_path_no=deflect_to(seg_OD,de_path_no,seg_hop_no);
                                if de_path_no==0
                                    %no deflection path, drop
                                    seg_de_no=100;
                                else
                                    occupy_seg=link_use(OD_path(seg_OD,de_path_no,seg_hop_no),:,1,1);
                                    isFree_seg=find(occupy_seg(:)==0);
                                    if arrival>10000
                                    arrival_path(seg_OD,de_path_no)=arrival_path(seg_OD,de_path_no)+(seg_last_bit-seg_new_first_bit)/packet_length;
                                    end
                                    if isempty(isFree_seg)
                                      seg_de_no=seg_de_no+1;  
                                    else
                                        channel=isFree_seg(floor(rand()*length(isFree_seg)+1));  %random select a free channel
                                        Burst_no_of_part(seg_reservation_no)=Burst_no_of_part(seg_reservation_no)+1;
                                        seg_new_part_no=Burst_no_of_part(seg_reservation_no);
                                        path_length=length(find(OD_path(seg_OD,de_path_no,:)>0));
                                        burst_finish_time=nextNewArrivalTime+seg_bits_seg/transmission_speed;
                                        link_use(OD_path(seg_OD,de_path_no,seg_hop_no),channel,1,:)=[1 seg_OD de_path_no seg_hop_no 100 burst_finish_time  seg_reservation_no seg_packet_no seg_bits_seg  seg_new_part_no seg_de_no seg_new_first_bit seg_last_bit];
                                        %update reservation_quequeseg_bits_seg
                                        slot=min(find(reservation_queque(seg_OD,:,1)==0));
                                        if isempty(slot)
                                            slot=length(reservation_queque(seg_OD,:,1))+1;
                                        end
                                        nextHopArrivalTime=nextNewArrivalTime+offset_time+link_length(OD_path(seg_OD,de_path_no,seg_hop_no))/propagation_speed;
                                        if (path_length-seg_hop_no+1>1)
                                            reservation_queque(seg_OD,slot,:)=[1 de_path_no seg_hop_no+1  nextHopArrivalTime seg_reservation_no seg_packet_no seg_bits_seg seg_new_part_no seg_de_no 100 seg_new_first_bit seg_last_bit];
                                            if nextBurst_come>nextHopArrivalTime
                                                nextBurst_come=nextHopArrivalTime;
                                            end
                                        end
                                        seg_de_no=100;
                                        
                                        good_calls(seg_reservation_no,seg_new_part_no,seg_hop_no*3-2+1)=OD_path(seg_OD,de_path_no,seg_hop_no);
                                        good_calls(seg_reservation_no,seg_new_part_no,seg_hop_no*3-2+2)=nextNewArrivalTime;
                                        new_arrival_time=nextNewArrivalTime;
                                        for i=seg_hop_no-1:-1:1
                                            new_arrival_time=new_arrival_time-link_length(OD_path(seg_OD,de_path_no,i))/propagation_speed-offset_time;
                                            good_calls(seg_reservation_no,seg_new_part_no,i*3-2+1)=OD_path(seg_OD,de_path_no,i);
                                            good_calls(seg_reservation_no,seg_new_part_no,i*3-2+2)=new_arrival_time;
                                        end
                                        
                                        
                                    end
                                end
                        end
                        if seg_de_no==4
                        end
                    end
             
                end
                
            else
                %free time slots, random choose one to fit
                reservation_count=reservation_count+1;
                good_calls(reservation_count,1,2)=OD_path(OD_pair,1,1);
                good_calls(reservation_count,1,3)=nextNewArrivalTime;
                Burst_no_of_part(reservation_count)=1;
                channel=isFree(floor(rand()*length(isFree)+1));  %random select a free channel
                link_use(OD_path(OD_pair,1,1),channel,1,:)=[1 OD_pair 1 1 path_length-1 burst_finish_time  reservation_count packet_no packet_no*packet_length 1 0 1 packet_no*packet_length];
                %update reservation_queque
                slot=min(find(reservation_queque(OD_pair,:,1)==0));
                if (path_length>1)
                    reservation_queque(OD_pair,slot,:)=[1 1 2  nextHopArrivalTime reservation_count packet_no packet_no*packet_length 1 0 path_length-1 1 packet_no*packet_length];
                    if nextBurst_come>nextHopArrivalTime
                        nextBurst_come=nextHopArrivalTime;
                    end
                end
                % update the next event time of different kinds
                
                
                if nextBurstEvent_finish>burst_finish_time
                    nextBurstEvent_finish=burst_finish_time;
                end
            end
            arrival=arrival+1;
            
            nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
            
        elseif (nextBurst_come<=nextBurstEvent_finish && nextBurst_come<=nextNewArrivalTime )
            % a control packet finish reserve in next hop
            %find the reservation number
            reservation=find(reservation_queque(:,:,4)==nextBurst_come);
            for k=1:length(reservation)
                %find the information of this reservation
                slot=floor((reservation(k)-1)/OD_no)+1;
                OD_pair=reservation(k)-(slot-1)*OD_no;
                hop_no=reservation_queque(OD_pair,slot,3);
                path_no=reservation_queque(OD_pair,slot,2);
                thisHop=OD_path(OD_pair,path_no,hop_no);
                path_length=length(find(OD_path(OD_pair,path_no,:)>0));
                burstArrivalTime=nextBurst_come;
                reservation_no=reservation_queque(OD_pair,slot,5);
                packet_no=reservation_queque(OD_pair,slot,6);
                left_burst_length=reservation_queque(OD_pair,slot,7);
                first_bit=reservation_queque(OD_pair,slot,11);
                last_bit=reservation_queque(OD_pair,slot,12);
                de_no=reservation_queque(OD_pair,slot,9);
                part_no=reservation_queque(OD_pair,slot,8);
                
                if de_no>0
                    %lowest priority
                    %calculate the information of the reservation
                    burstArrivalNextHopTime=burstArrivalTime+link_length(thisHop)/propagation_speed+offset_time;
                    burst_finish_time=burstArrivalTime+left_burst_length/transmission_speed;
                    occupy=link_use(thisHop,:,1,1);
                    isFree=find(occupy(:)==0);
%                     if arrival>10000
%                     arrival_path(OD_pair,path_no)=arrival_path(OD_pair,path_no)+left_burst_length/packet_length;
%                     end
                    if isempty(isFree)
                        if de_no==D_max
                            %block 
                            block(OD_pair)=block(OD_pair)+packet_no;
                            link_block(thisHop)=link_block(thisHop)+floor(left_burst_length/packet_length);
                            reservation_queque(OD_pair,slot,:)=zeros(1,12);
                            good_calls(reservation_no,part_no,:)=zeros(1,22*3+1);
                        else
                            de_no=de_no+1;
                            de_path_no=path_no;
                            link_block(thisHop)=link_block(thisHop)+floor(left_burst_length/packet_length);
                            while de_no<=D_max
                                de_path_no=deflect_to(OD_pair,de_path_no,hop_no);
                                if de_path_no==0
                                    %block
                                    de_no=100;
                                    block(OD_pair)=block(OD_pair)+packet_no;
                                    good_calls(reservation_no,part_no,:)=zeros(1,22*3+1);
                                    reservation_queque(OD_pair,slot,:)=zeros(1,12);
                                else
                                    new_link=OD_path(OD_pair,de_path_no,hop_no);
                                    occupy1=link_use(new_link,:,1,1);
                                    isFree1=find(occupy1(:)==0);
                                    if arrival>10000
                                        arrival_path(OD_pair,de_path_no)=arrival_path(OD_pair,de_path_no)+left_burst_length/packet_length;
                                    end
                                    if isempty(isFree1)
                                        de_no=de_no+1;
                                        link_block(new_link)=link_block(new_link)+floor(left_burst_length/packet_length);
                                    else
                                        %free slots
                                        channel=isFree1(floor(rand()*length(isFree1)+1));
                                        link_use(new_link,channel,1,:)=[1 OD_pair de_path_no hop_no 100 burst_finish_time  reservation_no packet_no left_burst_length part_no de_no first_bit last_bit];
                                        good_calls(reservation_no,part_no,hop_no*3-2+1)=new_link;
                                        good_calls(reservation_no,part_no,hop_no*3-1+1)=burstArrivalTime;
                                        %update the reservation_queque
                                        path_length=length(OD_path(OD_pair,de_path_no,:)>0);
                                        if hop_no==path_length
                                            %the control packet finish reservation
                                            reservation_queque(OD_pair,slot,:)=zeros(1,12);
                                        else
                                            burstArrivalNextHopTime=burstArrivalTime+link_length(new_link)/propagation_speed+offset_time;
                                            reservation_queque(OD_pair,slot,:)=[1  de_path_no hop_no+1 burstArrivalNextHopTime reservation_no packet_no left_burst_length part_no de_no 100 first_bit last_bit];
                                        end
                                        %update the time of events
                                        if nextBurstEvent_finish>burst_finish_time
                                            nextBurstEvent_finish=burst_finish_time;
                                        end
                                        de_no=100;
                                    end
                                    
                                end
                            end
                            if de_no==4
                                block(OD_pair)=block(OD_pair)+packet_no;
                                good_calls(reservation_no,part_no,:)=zeros(1,22*3+1);
                                reservation_queque(OD_pair,slot,:)=zeros(1,12);
                            end
                        end
                    else
                        channel=isFree(floor(rand()*length(isFree)+1));
                        link_use(thisHop,channel,1,:)=[1 OD_pair path_no hop_no path_length-hop_no burst_finish_time  reservation_no packet_no left_burst_length part_no de_no first_bit last_bit];
                        good_calls(reservation_no,part_no,hop_no*3-2+1)=thisHop;
                        good_calls(reservation_no,part_no,hop_no*3-1+1)=burstArrivalTime;
                        %update the reservation_queque
                        if hop_no==path_length
                            %the control packet finish reservation
                            reservation_queque(OD_pair,slot,:)=zeros(1,12);
                        else
                            reservation_queque(OD_pair,slot,:)=[1  path_no hop_no+1 burstArrivalNextHopTime reservation_no packet_no left_burst_length part_no de_no path_length-hop_no first_bit last_bit];
                        end
                        %update the time of events
                        if nextBurstEvent_finish>burst_finish_time
                            nextBurstEvent_finish=burst_finish_time;
                        end
                    end
                else
                    %de_no=0
                    burst_finish_time=burstArrivalTime+left_burst_length/transmission_speed;
                    burstArrivalNextHopTime=burstArrivalTime+link_length(thisHop)/propagation_speed+offset_time;
                    occupy=link_use(thisHop,:,1,1);
                    isFree=find(occupy(:)==0);
%                     if arrival>10000
%                         arrival_path(OD_pair,path_no)=arrival_path(OD_pair,path_no)+left_burst_length/packet_length;
%                     end
                    if isempty(isFree)
                        %find if can kick
                        xx=find(link_use(thisHop,:,1,5)>=path_length-hop_no+1);
                       if isempty(xx)
                            %no free slots, deflect the butst
                            link_block(thisHop)=link_block(thisHop)+packet_no;
                            burst_priority=100;
                            de_path_no=path_no;
                            while de_no<D_max
                                de_no=de_no+1;
                                de_path_no=deflect_to(OD_pair,de_path_no,hop_no);
                               
                                if de_path_no==0
                                    
                                    de_no=100;
                                    reservation_queque(OD_pair,slot,:)=zeros(1,12);
                                    good_calls(reservation_no,part_no,:)=zeros(1,22*3+1);
                                else
                                    if arrival>10000
                                        arrival_path(OD_pair,de_path_no)=arrival_path(OD_pair,de_path_no)+left_burst_length/packet_length;
                                    end
                                    new_link=OD_path(OD_pair,de_path_no,hop_no);
                                    occupy1=link_use(new_link,:,1,1);
                                    isFree1=find(occupy1(:)==0);
                                    if isempty(isFree1)
                                        link_block(new_link)=link_block(new_link)+left_burst_length/packet_length;
                                    else
                                        
                                        good_calls(reservation_no,part_no,hop_no*3-2+1)=new_link;
                                        good_calls(reservation_no,part_no,hop_no*3-2+2)=burstArrivalTime;
                                        channel=isFree1(floor(rand()*length(isFree1)+1));  %random select a free channel
                                        
                                        path_length=length(find(OD_path(OD_pair,de_path_no,:)>0));
                                        link_use(new_link,channel,1,:)=[1 OD_pair de_path_no hop_no 100 burst_finish_time  reservation_no packet_no left_burst_length part_no de_no first_bit  last_bit];
                                        
                                        %update reservation_queque
                                        
                                        nextHopArrivalTime=burstArrivalTime+offset_time+link_length(new_link)/propagation_speed;
                                        if (path_length>hop_no)
                                            reservation_queque(OD_pair,slot,:)=[1 de_path_no hop_no+1  nextHopArrivalTime reservation_no packet_no left_burst_length part_no de_no 100 first_bit last_bit];
                                            if nextBurst_come>nextHopArrivalTime
                                                nextBurst_come=nextHopArrivalTime;
                                            end
                                        else
                                            reservation_queque(OD_pair,slot,:)=zeros(1,12);
                                        end
                                        % update the next event time of different kinds
                                        if nextBurst_come>nextHopArrivalTime
                                            nextBurst_come=nextHopArrivalTime;
                                        end
                                        
                                        if nextBurstEvent_finish>burst_finish_time
                                            nextBurstEvent_finish=burst_finish_time;
                                        end
                                        de_no=100;
                                    end
                                end
                            end
                            if de_no==D_max
                                %block
                                reservation_queque(OD_pair,slot,:)=zeros(1,12);
                                good_calls(reservation_no,part_no,:)=zeros(1,22*3+1);
                            end
                       
                       else
                            %the call finds a channel with lower priority call serves,
                            %so the new call kicks the old one
                            max_length=max(link_use(thisHop,xx,1,5));
                            xxx=find(link_use(thisHop,:,1,5)==max_length);
                            
                            channel=xxx(floor(rand()*length(xxx)+1));
                            template=link_use(thisHop,channel,1,:);
                            %fit the burst
                            link_use(thisHop,channel,1,:)=[1 OD_pair path_no hop_no path_length-hop_no burst_finish_time  reservation_no packet_no left_burst_length part_no 0 first_bit last_bit];
                            %update reservation_queque
                            %update good_calls
                            good_calls(reservation_no,part_no,hop_no*3-2+1)=thisHop;
                            good_calls(reservation_no,part_no,hop_no*3-2+2)=burstArrivalTime;
                            if (path_length>hop_no)
                                reservation_queque(OD_pair,slot,:)=[1 path_no hop_no+1  burstArrivalNextHopTime reservation_no packet_no left_burst_length part_no 0 path_length-hop_no  first_bit last_bit];
                            else
                                
                                reservation_queque(OD_pair,slot,:)=zeros(1,12);
                            end
                            % update the next event time of different kinds
                            if nextBurst_come>nextHopArrivalTime
                                nextBurst_come=nextHopArrivalTime;
                            end
                            
                            if nextBurstEvent_finish>burst_finish_time
                                nextBurstEvent_finish=burst_finish_time;
                            end
                            % deal with the segmented burst the rest of the burst will deflect and the reservation_queque and the link_use need to update
                            seg_reservation_no=template(7);
                            
                            seg_path_no=template(3);
                            seg_de_no=template(11);
                            seg_part_no=template(10);
                            seg_hop_no=template(4);
                            seg_finish_time=template(6);
                            seg_bits_seg=round((seg_finish_time-burstArrivalTime)*transmission_speed);
                            seg_bits_left=template(9)-seg_bits_seg;
                            seg_last_bit=template(13);
                            seg_new_first_bit=seg_bits_left+1;
                            seg_packet_no=template(8);
                            
                            %deal with the bits left
                            seg_reservation=find(reservation_queque(:,:,5)==seg_reservation_no & reservation_queque(:,:,8)==seg_part_no);
                            slot=floor((seg_reservation-1)./OD_no)+1;
                            seg_OD=seg_reservation-(slot-1)*OD_no;
                            link_block(OD_path(OD_pair,1,1))=link_block(OD_path(OD_pair,1,1))+seg_bits_seg;
                            link_departure(OD_path(OD_pair,1,1))=link_departure(OD_path(OD_pair,1,1))+seg_bits_left;
                            if (reservation_queque(seg_OD,slot,7)>seg_bits_left)
                                reservation_queque(seg_OD,slot,7)=seg_bits_left;
                                reservation_queque(seg_OD,slot,12)=seg_new_first_bit-1;
                            end
                            
                            %need to update the link_use
                            calls=find(link_use(:,:,:,7)==seg_reservation_no &link_use(:,:,:,10)==seg_part_no);
                            seg_place=1; % always 1
                            seg_channel=floor((calls-1)/L+1);
                            seg_L=calls-(seg_channel-1)*L;
                            %the bits on the hop before this hop just let it finish, do not need to update,
                            for i=1:length(calls)
                                if link_use(seg_L(i),seg_channel(i),1,4)>template(4) && link_use(seg_L(i),seg_channel(i),1,9)>seg_bits_left
                                    %update the information of the hops after this seg hop
                                    time_save=(link_use(seg_L(i),seg_channel(i),1,9)-seg_bits_left)/transmission_speed;
                                    link_use(seg_L(i),seg_channel(i),1,9)=seg_bits_left;
                                    finish_time_new=link_use(seg_L(i),seg_channel(i),1,6)-time_save;
                                    link_use(seg_L(i),seg_channel(i),1,6)=finish_time_new;
                                    link_use(seg_L(i),seg_channel(i),1,13)=seg_new_first_bit-1;
                                    if nextBurstEvent_finish>finish_time_new
                                        nextBurstEvent_finish=finish_time_new;
                                    end
                                end
                            end
                            
                            
                            %deal with the segmented part
                            priority_no=100;
                            if seg_de_no==D_max
                                %can not deflect again, drop
                            else
                                %deflected
                                de_path_no=seg_path_no;
                                seg_de_no=seg_de_no+1;
                                while seg_de_no<=D_max
                                    de_path_no=deflect_to(seg_OD,de_path_no,seg_hop_no);
                                    if de_path_no==0
                                        %no deflection path, drop
                                        seg_de_no=100;
                                    else
                                        occupy_seg=link_use(OD_path(seg_OD,de_path_no,seg_hop_no),:,1,1);
                                        isFree_seg=find(occupy_seg(:)==0);
                                        if arrival>10000
                                        arrival_path(seg_OD,de_path_no)=arrival_path(seg_OD,de_path_no)+(seg_last_bit-seg_new_first_bit)/packet_length;
                                        end
                                        if isempty(isFree_seg)
                                            seg_de_no=seg_de_no+1;
                                        else
                                            channel=isFree_seg(floor(rand()*length(isFree_seg)+1));  %random select a free channel
                                            Burst_no_of_part(seg_reservation_no)=Burst_no_of_part(seg_reservation_no)+1;
                                            seg_new_part_no=Burst_no_of_part(seg_reservation_no);
                                            path_length=length(find(OD_path(seg_OD,de_path_no,:)>0));
                                            burst_finish_time=burstArrivalTime+seg_bits_seg/transmission_speed;
                                            link_use(OD_path(seg_OD,de_path_no,seg_hop_no),channel,1,:)=[1 OD_pair de_path_no seg_hop_no 100 burst_finish_time  seg_reservation_no seg_packet_no  seg_bits_seg seg_new_part_no seg_de_no seg_new_first_bit seg_last_bit];
                                            %update reservation_quequeseg_bits_seg
                                            slot11=min(find(reservation_queque(seg_OD,:,1)==0));
                                            nextHopArrivalTime=burstArrivalTime+offset_time+link_length(OD_path(seg_OD,de_path_no,seg_hop_no))/propagation_speed;
                                            if (path_length-seg_hop_no+1>1)
                                                reservation_queque(seg_OD,slot11,:)=[1 de_path_no seg_hop_no+1  nextHopArrivalTime seg_reservation_no seg_packet_no seg_bits_seg seg_new_part_no seg_de_no 100 seg_new_first_bit seg_last_bit];
                                                if nextBurst_come>nextHopArrivalTime
                                                    nextBurst_come=nextHopArrivalTime;
                                                end
                                            end
                                            seg_de_no=100;
                                            
                                            good_calls(seg_reservation_no,seg_new_part_no,seg_hop_no*3-2+1)=OD_path(seg_OD,de_path_no,seg_hop_no);
                                            good_calls(seg_reservation_no,seg_new_part_no,seg_hop_no*3-2+2)=burstArrivalTime;
                                            new_arrival_time=burstArrivalTime;
                                            for i=seg_hop_no-1:-1:1
                                                new_arrival_time=new_arrival_time-link_length(OD_path(seg_OD,de_path_no,i))/propagation_speed-offset_time;
                                                good_calls(seg_reservation_no,seg_new_part_no,i*3-2+1)=OD_path(seg_OD,de_path_no,i);
                                                good_calls(seg_reservation_no,seg_new_part_no,i*3-2+2)=new_arrival_time;
                                            end
                                            
                                            
                                        end
                                    end
                                end
                                if seg_de_no==4
                                end
                            end
                             
                       end
                    else
                        channel=isFree(floor(rand()*length(isFree)+1));
                        link_use(thisHop,channel,1,:)=[1 OD_pair path_no hop_no path_length-hop_no burst_finish_time  reservation_no packet_no left_burst_length part_no de_no first_bit last_bit];
                        good_calls(reservation_no,part_no,hop_no*3-2+1)=thisHop;
                        good_calls(reservation_no,part_no,hop_no*3-1+1)=burstArrivalTime;
                        %update the reservation_queque
                        if hop_no==path_length
                            %the control packet finish reservation
                            reservation_queque(OD_pair,slot,:)=zeros(1,12);
                        else
                            reservation_queque(OD_pair,slot,:)=[1  path_no hop_no+1 burstArrivalNextHopTime reservation_no packet_no left_burst_length part_no de_no path_length-hop_no first_bit last_bit];
                            if nextBurst_come>nextHopArrivalTime
                                nextBurst_come=nextHopArrivalTime;
                            end
                        end
                        %update the time of events
                        if nextBurstEvent_finish>burst_finish_time
                            nextBurstEvent_finish=burst_finish_time;
                        end
                    end
                end
            end
            
            control_event=reservation_queque(:,:,4);
            nextBurst_come=min(control_event(control_event~=0));
            if isempty(nextBurst_come)
                nextBurst_come=1e20;
            end
         
        else
            %a burst finish serving in a hop and release the resource
            burst=find(link_use(:,:,1,6)==nextBurstEvent_finish);
            for k=1:length(burst)
                channel=floor((burst(k)-1)/L)+1;
                link=burst(k)-(channel-1)*L;
                OD_pair=link_use(link,channel,1,2);
                %check if this hop is the last hop of the path (if so, the call leave the network
                path_no=link_use(link,channel,1,3);
                packet_no=link_use(link,channel,1,8);
                left_burst_length=link_use(link,channel,1,9);
                
                path_length=length(find(OD_path(OD_pair,path_no,:)>0));
                link_departure(link)=link_departure(link)+floor(left_burst_length/packet_length);
                hop_no=link_use(link,channel,1,4);
                if (hop_no==path_length)
                    %the burst leave the network
                    first_bit=link_use(link,channel,1,12);
                    last_bit=link_use(link,channel,1,13);
                    reservation_no=link_use(link,channel,1,7);
                    part_no=link_use(link,channel,1,10);
                    first_packet=ceil((first_bit-1)/packet_length)+1;
                    last_packet=floor(last_bit/packet_length);
                    
%                     receive_table(reservation_no,1)=OD_pair;
%                     receive_table(reservation_no,2)=packet_no;
%                     for i=first_packet:1:last_packet
%                         receive_table(i+2)=1;
%                     end
                    received_packet=last_packet-first_packet+1;
                    if (arrival>10000)
                     departure(OD_pair)=departure(OD_pair)+received_packet;
                     departure_path(OD_pair,path_no)=departure_path(OD_pair,path_no)+received_packet;
                    end
%                     block(OD_pair)=block(OD_pair)+(packet_no-received_packet);
                    %update the finish time of the good_calls
                    if received_packet>0
                        efficient_service_time=received_packet*packet_length/transmission_speed;
                        good_calls(reservation_no,part_no,1)=1;
                        time_waste_at_first=((first_packet-1)*packet_length-first_bit+1)/transmission_speed;
                        for j=1:path_length
                            
                            good_calls(reservation_no,part_no,j*3)=good_calls(reservation_no,part_no,j*3)+time_waste_at_first;
                            good_calls(reservation_no,part_no,j*3+1)=good_calls(reservation_no,part_no,j*3)+efficient_service_time;
                        end
                    else
                        good_calls(reservation_no,part_no,:)=zeros(1,22*3+1);
                    end
                end
                %release the resource
                link_use(link,channel,1,:)=zeros(1,13);
            end
          
            burst_event=link_use(:,:,1,6);
            nextBurstEvent_finish=min(burst_event(burst_event~=0));
            if isempty(nextBurstEvent_finish)
                nextBurstEvent_finish=1e20;
            end
        end
    end
    total_block(traf)=sum(1-departure./packet_arrival)/OD_no
  % total_block2(traf)=sum(block./(block+departure))/OD_no 
  link_b(traf,:)=link_block./(link_block+link_departure);
  
  fid = fopen('NSF_EBSL_D_low_traffic_33.txt','wt'); 
    fprintf(fid,'%c','link_block=[ ');
    for k=1:L
        for q=1:traf
            p_B=num2str(link_b(q,k));
            fprintf(fid,'%c',p_B);
            fprintf(fid,'%c',' ');
        end
         fprintf(fid,'%c',' ... ');
         fprintf(fid,'%c\n',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' ');   
    
    utilization=zeros(L,1);
    for i=1:L
        state_sum=sum(state_probability(i,:));
        state_probability(i,:)=state_probability(i,:)/state_sum;
        average=0;
        for j=1:C+1
            average=average+state_probability(i,j)*(j-1)/C;
        end
        utilization(i)=utilization(i)+average;
    end
    
    U(traf)=sum(utilization)/L
    
    
     goodU_link=zeros(1,L);

    
    
    
    

    goodput(traf)=sum((departure./packet_arrival).*traffic(1))
    goodput_s(traf,:)=(departure./packet_arrival).*traffic(1);
    fprintf(fid,'%c','goodput_OD=[ ');
    for k=1:OD_no
        for q=1:traf
            p_B=num2str(goodput_s(q,k));
            fprintf(fid,'%c',p_B);
            fprintf(fid,'%c',' ');
        end
         fprintf(fid,'%c',' ... ');
         fprintf(fid,'%c\n',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' ');
    fprintf(fid,'%c\n',' ');
    

    no_good_calls=length(good_calls(:,1));
    inspector_no=Simulation/10;
    inspector_interval=exprnd(1.1/(sum(lambda)),[1,inspector_no]);
    inspector=zeros(1,inspector_no);
    inspector(1)=1/(sum(lambda))*10000;
    for i=2:inspector_no
        inspector(i)=inspector(i-1)+inspector_interval(i-1);
    end
    good_utilization_count=zeros(inspector_no,L);
    
    for i=1:no_good_calls
        for k=1:20
            if good_calls(i,k,1)==0
            else
                path_length=(length(find(good_calls(i,k,:)>0))-1)/3;
                for j=1:path_length
                    x=min(find(inspector(:)>=good_calls(i,k,j*3)));
                    y=max(find(inspector(:)<good_calls(i,k,j*3+1)));
                    if x<=y
                        for q=x:y
                            good_utilization_count(q,good_calls(i,k,j*3-1))=good_utilization_count(q,good_calls(i,k,j*3-1))+1;
                        end
                    end
                end
            end
        end
    end
    
    efficient_state_probability=zeros(L,100);
    for i=1:L
        for j=1:inspector_no
            state=good_utilization_count(j,i);
            efficient_state_probability(i,state+1)=efficient_state_probability(i,state+1)+1;
        end
    end
    efficient_utilization=zeros(1,L);
    for i=1:L
        state_sum=sum(efficient_state_probability(i,:));
        efficient_state_probability(i,:)=efficient_state_probability(i,:)/state_sum;
        average=0;
        for j=1:100
            average=average+efficient_state_probability(i,j)*(j-1)/C;
        end
        efficient_utilization(i)=efficient_utilization(i)+average; 
    end
    EU(traf)=sum(efficient_utilization)/L
    EU_s(traf,:)=efficient_utilization;
     
    fprintf(fid,'%c','total_block=[ ');
    for k=1:traf 
         p_B=num2str(total_block(k));
        fprintf(fid,'%c',p_B);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','U=[ ');
    for k=1:traf;
         p_U=num2str(U(k));
        fprintf(fid,'%c',p_U);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
    fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','goodput=[ ');
    for k=1:traf 
         p_g=num2str(goodput(k));
        fprintf(fid,'%c',p_g);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',']; ');
    fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','EU=[ ');
    for k=1:traf
        p_EU=num2str(EU(k));
        fprintf(fid,'%c',p_EU);
        fprintf(fid,'%c',' ');
    end
    fprintf(fid,'%c\n',']; ');
    
    
    
    fprintf(fid,'%c','EU_link=[ ');
    for k=1:L
        for q=1:traf
            p_B=num2str(EU_s(q,k));
            fprintf(fid,'%c',p_B);
            fprintf(fid,'%c',' ');
        end
        fprintf(fid,'%c',' ... ');
        fprintf(fid,'%c\n',' ');
    end
    fprintf(fid,'%c',' ];');
    fprintf(fid,'%c\n',' ');
    fclose(fid); 
    
end


