%---------------------------
%discrete event simulation
%the time is counted in microseconds
%1 second=1000  milliseconds=10^6 microseconds
%NSFNet 
%OCS
%---------------------------
clear all;
format long;
propagation_speed=3*1e8/1e6;
%propagation_speed=1e20;
switching_delay=0; %usually smaller than 1, so ignore
%offset_time=10; %micorseconds
packet_length=1250*8; %bits
%packet_length=1250;
%average burst length=2.5MB
packet_no_ave=250;
transmission_speed=10*1e9/1e6; %bit/micros

Simulation=3e5;
node=14;
L=42;
OD_no=node*(node-1);
C=50;
%OD_path=zeros(30,7);

Traffic=0.1*[  0.1 0.13 0.16  0.2  0.3  0.5  1  2   3    5  ];


OD_path=calculate_routing_table_nsf();
link_length=[260 260 252 252 380 380 324 324 868 868 416  416 272 272 248 248 292 292 212  212 224 224 704 704 1036 1036 1140 1140 408 408 536 536 668 668 684 684 664 664 352 352 752 752]*1000;

path_length=zeros(1,OD_no);
for i=1:OD_no
        path_hop=length(find(OD_path(i,:)>0));
        for j=1:path_hop
            path_length(i)=path_length(i)+link_length(OD_path(i,j));
        end
end
        



for traf=1:length(Traffic)
    traffic=Traffic(traf)*(packet_length*packet_no_ave/transmission_speed);
    
    service_time=path_length/propagation_speed+packet_length*packet_no_ave/transmission_speed;
    lambda=traffic./service_time;  %busrts/micosecond
    
    %propagation_daley_link=link_length./propagation_speed;
    buffer=1;
    link_use=zeros(L,C,1+buffer,4);%layer-1 1-occupy or not; 2-OD_pair; 3-finish time; 4-burst length (no. of packets);
    %layer-2 1-waiting or not;
    %2-OD_pair; 3-hop no.; 4 -min start time;
    %5-max leave time 6-reservation_no 7-burst length (no. of packets) ;
    buffer2=40000;
    reservation_queque=zeros(OD_no,buffer2,5);%1-occupy or not 2-next hop no 3 next hop arrival time 4-reservation_no 5-burst length (no. of packets)
    
    block=zeros(1,OD_no);
    departure=zeros(1,OD_no);
    
    link_block=zeros(1,L);
    link_departure=zeros(1,L);
    OD_arrival=zeros(1,OD_no);
    link_OD_departure=zeros(OD_no,L);
    good_calls=zeros(Simulation,3); %1-OD number, 2-arrival time 3-finish time 
    
    arrivelIntervalTime_control(1:Simulation) = exprnd(1/(sum(lambda)),[1,Simulation]);  % ariival of the control packets, follow possion distribution
    nextNewArrivalTime=arrivelIntervalTime_control(1);
    rd=rand();
    part_arrival=lambda(1);
    finish=0;
    count=1;
    while (finish==0)
        if rd<part_arrival/sum(lambda)
            OD_pair=count;
            finish=1;
        else
            count=count+1;
            part_arrival=part_arrival+lambda(count);
        end
    end
    packet_no=floor(exprnd(packet_no_ave,1));
    path_hop=length(find(OD_path(OD_pair,:)>0));  %find the length of the path;
    
    % calculate the happen time of the next event of different kinds
    
    nextBurstEvent_finish=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length(OD_pair)/propagation_speed;  %the time of the call finish serving in this hop
    %record in the table
    for i=1:path_hop
        link_use(OD_path(OD_pair,i),1,1,:)=[1 OD_pair nextBurstEvent_finish packet_no ];
    end
    departure(OD_pair)=departure(OD_pair)+packet_no;
    state_probability=zeros(L,C+1);
    good_calls(1,1)=OD_pair;
    good_calls(1,2)=nextNewArrivalTime;
    good_calls(1,3)=nextBurstEvent_finish;
    
    good_call_count=1;   
    arrival=1;
    nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
    while arrival<Simulation-1
        
            %a new control packet finish reserve the resource ( reserving resources ), a new call comes into the network
            %generate the OD no, path length of the new control packet and the arrival time of the new burst
            
            if arrival>5000
                for iii=1:L
                    xx=link_use(iii,:,1,3)>nextNewArrivalTime;
                    x=sum(xx);
                    state_probability(iii,x+1)=state_probability(iii,x+1)+1;
                end
            end
            
            rd=rand();
            part_arrival=lambda(1);
            finish=0;
            count=1;
            while (finish==0)
                if rd<part_arrival/sum(lambda)
                    OD_pair=count;
                    finish=1;
                else
                    count=count+1;
                    part_arrival=part_arrival+lambda(count);
                end
            end
            packet_no=floor(exprnd(packet_no_ave,1)); %generate the number of packets of the burs
            path_hop=length(find(OD_path(OD_pair,:)>0)); 
            
            call_finish_time=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length(OD_pair)/propagation_speed;
          
            
            OD_arrival(OD_pair)=OD_arrival(OD_pair)+packet_no;
            
            %find free path
            occupy=zeros(path_hop,C);
            isFree_channel=zeros(1,path_hop);
            for i=1:path_hop
                occupy(i,:)=link_use(OD_path(OD_pair,i),:,1,3)<nextNewArrivalTime;
                if sum(occupy(i,:))>0
                    isFree_channel(i)=1;
                else
                    isFree_channel(i)=0;
                end
            end
            if sum(isFree_channel)<path_hop
                %no free slots, block the reservation
                block(OD_pair)=block(OD_pair)+packet_no;
                %link_block(OD_path(OD_pair,1))=link_block(OD_path(OD_pair,1))+packet_no;
                
            else
                %free time slots, random choose one to fit
                for i=1:path_hop
                    isFree=find(occupy(i,:)==1);
                	channel=isFree(floor(rand()*length(isFree)+1));  %random select a free channel
                    link_use(OD_path(OD_pair,i),channel,1,:)=[1 OD_pair call_finish_time packet_no];
                end
                good_call_count=good_call_count+1;
                good_calls(good_call_count,1)=OD_pair;
                good_calls(good_call_count,2)=nextNewArrivalTime;
                good_calls(good_call_count,3)=call_finish_time;
                departure(OD_pair)=departure(OD_pair)+packet_no;
            end
            arrival=arrival+1;
            nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
    end

    total_block(traf)=sum(block./(block+departure))/OD_no
    
    
    
    utilization=zeros(L,1);
    for i=1:L
        state_sum=sum(state_probability(i,:));
        state_probability(i,:)=state_probability(i,:)/state_sum;
        average=0;
        for j=1:C+1
            average=average+state_probability(i,j)*(j-1)/C;
        end
        utilization(i)=utilization(i)+average;
    end
    
    U(traf)=sum(utilization)/L
    goodput(traf)=sum((1-block./(block+departure)).*traffic)
    
%     goodU_link=zeros(1,L);
%     
%     carried_link=zeros(1,L);
%     arrival_link=zeros(1,L);
%     for i=1:OD_no
%         for j=1:3
%             goodU_link(OD_path(i,j))=goodU_link(OD_path(i,j))+(1-block(i)/(block(i)+departure(i)))*traffic(i);
%         end
%     end
%     goodutilization=goodU_link/C;
%     goodU(traf)=sum(goodutilization)/L
%     badU(traf)=U(traf)-goodU(traf)
%     
%     link_b=link_block./(link_block+link_departure);
%     offered_link=zeros(1,L);
%     for i=1:OD_no
%         offered_link(OD_path(i,1))=offered_link(OD_path(i,1))+traffic(i)*link_OD_departure(i,OD_path(i,1))/OD_arrival(i);
%         offered_link(OD_path(i,2))=offered_link(OD_path(i,2))+traffic(i)*link_OD_departure(i,OD_path(i,2))/OD_arrival(i);
%         offered_link(OD_path(i,3))=offered_link(OD_path(i,3))+traffic(i)*link_OD_departure(i,OD_path(i,3))/OD_arrival(i);
%     end
%     U_new(traf)=sum(offered_link./C)/L
    
    
%      for i=Simulation:-1:1
%         if good_calls(i,9)==0
%         else
%             good_calls(i,:)=[];
%         end
%     end
    no_good_calls=length(find(good_calls(:,1)>0));
    inspector_interval=exprnd(1.1/(sum(lambda)),[1,Simulation/2]);
    inspector=zeros(1,Simulation/2);
    inspector(1)=1/(sum(lambda))*1000;
    for i=2:Simulation/2
        inspector(i)=inspector(i-1)+inspector_interval(i-1);
    end
    good_utilization_count=zeros(Simulation/2,L);
    
    for i=1:no_good_calls
        
        
            x=min(find(inspector(:)>=good_calls(i,2)));
            y=max(find(inspector(:)<good_calls(i,3)));
            if x<=y
                path_length1=find(OD_path(good_calls(i,1),:)>0);
                for j=x:y
                    for k=1:path_length1
                    good_utilization_count(j,OD_path(good_calls(i,1),k))=good_utilization_count(j,OD_path(good_calls(i,1),k))+1;
                    end
                end
            end
            
        
    end
    
    efficient_state_probability=zeros(L,C+1);
    for i=1:L
        for j=1:Simulation/2
            state=good_utilization_count(j,i);
            efficient_state_probability(i,state+1)=efficient_state_probability(i,state+1)+1;
        end
    end
    efficient_utilization=zeros(1,L);
    for i=1:L
        state_sum=sum(efficient_state_probability(i,:));
        efficient_state_probability(i,:)=efficient_state_probability(i,:)/state_sum;
        average=0;
        for j=1:C+1
            average=average+efficient_state_probability(i,j)*(j-1)/C;
        end
        efficient_utilization(i)=efficient_utilization(i)+average; 
    end
    EU(traf)=sum(efficient_utilization)/L
    
       fid = fopen('NSF_OCS_5.txt','wt'); 
    fprintf(fid,'%c','total_block=[ ');
    for k=1:traf 
         p_B=num2str(total_block(k));
        fprintf(fid,'%c',p_B);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','U=[ ');
    for k=1:traf;
         p_U=num2str(U(k));
        fprintf(fid,'%c',p_U);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
    fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','goodput=[ ');
    for k=1:traf 
         p_g=num2str(goodput(k));
        fprintf(fid,'%c',p_g);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',']; ');
    fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','EU=[ ');
    for k=1:traf
         p_EU=num2str(EU(k));
        fprintf(fid,'%c',p_EU);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',']; ');
     fprintf(fid,'%c\n',' ');
     fprintf(fid,'%c\n',' ');
     goodput_s(traf,:)=(1-block./(block+departure)).*traffic;
    fprintf(fid,'%c','goodput_OD=[ ');
    for k=1:OD_no
        for q=1:traf
            p_B=num2str(goodput_s(q,k));
            fprintf(fid,'%c',p_B);
            fprintf(fid,'%c',' ');
        end
         fprintf(fid,'%c',' ... ');
         fprintf(fid,'%c\n',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' ');
    fprintf(fid,'%c\n',' ');
     EU_s(traf,:)=efficient_utilization;
     fprintf(fid,'%c','EU_link=[ ');
    for k=1:L
        for q=1:traf
            p_B=num2str(EU_s(q,k));
            fprintf(fid,'%c',p_B);
            fprintf(fid,'%c',' ');
        end
         fprintf(fid,'%c',' ... ');
         fprintf(fid,'%c\n',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' '); 
     fclose(fid);
end


