%---------------------------
%discrete event simulation
%the time is counted in microseconds 
%1 second=1000  milliseconds=10^6 microseconds
%NSFNet
%OCS with deflection
%---------------------------
clear all;
format long;
propagation_speed=3*1e8/1e6;
%propagation_speed=1e20;
switching_delay=0; %usually smaller than 1, so ignore
%offset_time=10; %micorseconds
packet_length=1250*8; %bits
%packet_length=1250;
%average burst length=2.5MB
packet_no_ave=250;
transmission_speed=10*1e9/1e6; %bit/micros

Simulation=1e6;
node=14;
L=42;
OD_no=node*(node-1);
C=50;
%OD_path=zeros(30,7);

Traffic=0.1*[  0.1 0.13 0.16  0.2  0.3  0.5  1  2   3    5  ]; %traffic for each SD pair


OD_path=calculate_routing_table_nsf_add_alternate();  %routing table
link_length=[260 260 252 252 380 380 324 324 868 868 416  416 272 272 248 248 292 292 212  212 224 224 704 704 1036 1036 1140 1140 408 408 536 536 668 668 684 684 664 664 352 352 752 752]*1000;

path_length=zeros(OD_no,4);
for i=1:OD_no
    for k=1:4
        path_hop=length(find(OD_path(i,k,:)>0));
        for j=1:path_hop
            path_length(i,k)=path_length(i)+link_length(OD_path(i,k,j));
        end
    end
end
        

Max_de=3;

for traf=1:length(Traffic)
    traffic=Traffic(traf)*(packet_length*packet_no_ave/transmission_speed);
    
    service_time=path_length(:,1)/propagation_speed+packet_length*packet_no_ave/transmission_speed;
    lambda=traffic./service_time;  %busrts/micosecond
    
    %propagation_daley_link=link_length./propagation_speed;
    buffer=1;
    link_use=zeros(L,C,1+buffer,5);%layer-1 1-occupy or not; 2-OD_pair; 3-finish time; 4-burst length (no. of packets) 5 deflection time;
    %layer-2 1-waiting or not;
    %2-OD_pair; 3-hop no.; 4 -min start time;
    %5-max leave time 6-reservation_no 7-burst length (no. of packets) ;
    %buffer2=40000;
    %reservation_queque=zeros(OD_no,buffer2,5);%1-occupy or not 2-next hop no 3 next hop arrival time 4-reservation_no 5-burst length (no. of packets)
    
    block=zeros(1,OD_no);
    departure=zeros(1,OD_no);
    
    link_block=zeros(1,L);
    link_departure=zeros(1,L);
    OD_arrival=zeros(1,OD_no);
    link_OD_departure=zeros(OD_no,L);
    good_calls=zeros(Simulation,5); %1-OD number, 2-arrival time 3-finish time 4-path_no
    
    arrivelIntervalTime_control(1:Simulation)=exprnd(1/(sum(lambda)),[1,Simulation]);  % arrival of the control packets, follow possion distribution
    nextNewArrivalTime=arrivelIntervalTime_control(1);
    rd=rand();
    part_arrival=lambda(1);
    finish=0;
    count=1;
    while (finish==0)
        if rd<part_arrival/sum(lambda)
            OD_pair=count;
            finish=1;
        else
            count=count+1;
            part_arrival=part_arrival+lambda(count);
        end
    end
    packet_no=floor(exprnd(packet_no_ave,1));
    path_hop=length(find(OD_path(OD_pair,1,:)>0));  %find the length of the path;
    
    % calculate the happen time of the next event of different kinds
    
    nextBurstEvent_finish=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length(OD_pair,1)/propagation_speed;  %the time of the call finish serving in this hop
    %record in the table
    for i=1:path_hop
        link_use(OD_path(OD_pair,1,i),1,1,:)=[1 OD_pair nextBurstEvent_finish packet_no 0];
    end
    departure(OD_pair)=departure(OD_pair)+packet_no;
    state_probability=zeros(L,C+1);
    good_calls(1,1:4)=[OD_pair nextNewArrivalTime nextBurstEvent_finish 1];
    
    
    good_call_count=1;   
    arrival=1;
    nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
    while arrival<Simulation-1
        
            %a new control packet finish reserve the resource ( reserving resources ), a new call comes into the network
            %generate the OD no, path length of the new control packet and the arrival time of the new burst
            
            if arrival>5000
                for iii=1:L
                    xx=link_use(iii,:,1,3)>nextNewArrivalTime;
                    x=sum(xx);
                    state_probability(iii,x+1)=state_probability(iii,x+1)+1;
                end
            end
            
            rd=rand();
            part_arrival=lambda(1);
            finish=0;
            count=1;
            while (finish==0)
                if rd<part_arrival/sum(lambda)
                    OD_pair=count;
                    finish=1;
                else
                    count=count+1;
                    part_arrival=part_arrival+lambda(count);
                end
            end
            packet_no=floor(exprnd(packet_no_ave,1)); %generate the number of packets of the burs
            path_hop=length(find(OD_path(OD_pair,1,:)>0)); 
            
            call_finish_time=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length(OD_pair,1)/propagation_speed;
          
            
            OD_arrival(OD_pair)=OD_arrival(OD_pair)+packet_no;
            
            %find free path
            occupy=zeros(path_hop,C);
            isFree_channel=zeros(1,path_hop);
            for i=1:path_hop
                occupy(i,:)=link_use(OD_path(OD_pair,1,i),:,1,3)<nextNewArrivalTime;
                if sum(occupy(i,:))>0
                    isFree_channel(i)=1;
                else
                    isFree_channel(i)=0;
                end
            end
            if sum(isFree_channel)<path_hop
                %no free path,find alternate
                Def=1;
                path_hop=length(find(OD_path(OD_pair,2,:)>0)); 
                if path_hop==0
                    %no deflection route
                    block(OD_pair)=block(OD_pair)+packet_no;
                else
                    occupy=zeros(path_hop,C);
                    isFree_channel=zeros(1,path_hop);
                    for i=1:path_hop
                        occupy(i,:)=link_use(OD_path(OD_pair,2,i),:,1,3)<nextNewArrivalTime;
                        if sum(occupy(i,:))>0
                            isFree_channel(i)=1;
                        else
                            isFree_channel(i)=0;
                        end
                    end
                    if sum(isFree_channel)<path_hop
                        %no free path, deflect
                        Def=2;
                        path_hop=length(find(OD_path(OD_pair,3,:)>0));
                        if path_hop==0
                            %no deflection route
                            block(OD_pair)=block(OD_pair)+packet_no;
                        else
                            occupy=zeros(path_hop,C);
                            isFree_channel=zeros(1,path_hop);
                            for i=1:path_hop
                                occupy(i,:)=link_use(OD_path(OD_pair,3,i),:,1,3)<nextNewArrivalTime;
                                if sum(occupy(i,:))>0
                                    isFree_channel(i)=1;
                                else
                                    isFree_channel(i)=0;
                                end
                            end
                            if sum(isFree_channel)<path_hop
                                %no free path, deflect
                                Def=3;
                                path_hop=length(find(OD_path(OD_pair,4,:)>0));
                                if path_hop==0
                                    %no deflection route
                                    block(OD_pair)=block(OD_pair)+packet_no;
                                else
                                    occupy=zeros(path_hop,C);
                                    isFree_channel=zeros(1,path_hop);
                                    for i=1:path_hop
                                        occupy(i,:)=link_use(OD_path(OD_pair,4,i),:,1,3)<nextNewArrivalTime;
                                        if sum(occupy(i,:))>0
                                            isFree_channel(i)=1;
                                        else
                                            isFree_channel(i)=0;
                                        end
                                    end
                                    if sum(isFree_channel)<path_hop
                                        block(OD_pair)=block(OD_pair)+packet_no;
                                    else
                                        call_finish_time=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length(OD_pair,4)/propagation_speed;
                                        for i=1:path_hop
                                            isFree=find(occupy(i,:)==1);
                                            channel=isFree(floor(rand()*length(isFree)+1));  %random select a free channel
                                            link_use(OD_path(OD_pair,4,i),channel,1,:)=[1 OD_pair call_finish_time packet_no 3];
                                        end
                                        good_calls(good_call_count,1:4)=[OD_pair nextNewArrivalTime call_finish_time 4];
                                        departure(OD_pair)=departure(OD_pair)+packet_no;
                                    end
                                end
                            else
                                call_finish_time=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length(OD_pair,3)/propagation_speed;
                                for i=1:path_hop
                                    isFree=find(occupy(i,:)==1);
                                    channel=isFree(floor(rand()*length(isFree)+1));  %random select a free channel
                                    link_use(OD_path(OD_pair,3,i),channel,1,:)=[1 OD_pair call_finish_time packet_no 2];
                                end
                                good_calls(good_call_count,1:4)=[OD_pair nextNewArrivalTime call_finish_time 3];
                                departure(OD_pair)=departure(OD_pair)+packet_no;
                            end
                        end
                    else
                        call_finish_time=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length(OD_pair,2)/propagation_speed;
                        for i=1:path_hop
                            isFree=find(occupy(i,:)==1);
                            channel=isFree(floor(rand()*length(isFree)+1));  %random select a free channel
                            link_use(OD_path(OD_pair,2,i),channel,1,:)=[1 OD_pair call_finish_time packet_no 1];
                        end
                        good_calls(good_call_count,1:4)=[OD_pair nextNewArrivalTime call_finish_time 2];
                        departure(OD_pair)=departure(OD_pair)+packet_no;
                    end
                end
                 
            else
                %free time slots, random choose one to fit
                for i=1:path_hop
                    isFree=find(occupy(i,:)==1);
                	channel=isFree(floor(rand()*length(isFree)+1));  %random select a free channel
                    link_use(OD_path(OD_pair,1,i),channel,1,:)=[1 OD_pair call_finish_time packet_no 0];
                end
                good_call_count=good_call_count+1;
                good_calls(good_call_count,1:4)=[OD_pair nextNewArrivalTime call_finish_time 1];
                departure(OD_pair)=departure(OD_pair)+packet_no;
            end
            arrival=arrival+1;
            nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
    end

    total_block(traf)=sum(block./(block+departure))/OD_no
    
    
    
    utilization=zeros(L,1);
    for i=1:L
        state_sum=sum(state_probability(i,:));
        state_probability(i,:)=state_probability(i,:)/state_sum;
        average=0;
        for j=1:C+1
            average=average+state_probability(i,j)*(j-1)/C;
        end
        utilization(i)=utilization(i)+average;
    end
    
    U(traf)=sum(utilization)/L
    goodput(traf)=sum((1-block./(block+departure)).*traffic)

    
       fid = fopen('NSF_OCS_de_add.txt','wt'); 
    fprintf(fid,'%c','total_block=[ ');
    for k=1:traf 
         p_B=num2str(total_block(k));
        fprintf(fid,'%c',p_B);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','U=[ ');
    for k=1:traf;
         p_U=num2str(U(k));
        fprintf(fid,'%c',p_U);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
    fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','goodput=[ ');
    for k=1:traf 
         p_g=num2str(goodput(k));
        fprintf(fid,'%c',p_g);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',']; ');
    fprintf(fid,'%c\n',' '); 
%     fprintf(fid,'%c','EU=[ ');
%     for k=1:traf
%          p_EU=num2str(EU(k));
%         fprintf(fid,'%c',p_EU);  
%         fprintf(fid,'%c',' '); 
%     end
%     fprintf(fid,'%c',']; ');
%      fprintf(fid,'%c\n',' ');
%      fprintf(fid,'%c\n',' ');
     goodput_s(traf,:)=(1-block./(block+departure)).*traffic;
    fprintf(fid,'%c','goodput_OD=[ ');
    for k=1:OD_no
        for q=1:traf
            p_B=num2str(goodput_s(q,k));
            fprintf(fid,'%c',p_B);
            fprintf(fid,'%c',' ');
        end
         fprintf(fid,'%c',' ... ');
         fprintf(fid,'%c\n',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' ');
    fprintf(fid,'%c\n',' ');
%     EU_s(traf,:)=efficient_utilization;
%      fprintf(fid,'%c','EU_link=[ ');
%     for k=1:L
%         for q=1:traf
%             p_B=num2str(EU_s(q,k));
%             fprintf(fid,'%c',p_B);
%             fprintf(fid,'%c',' ');
%         end
%          fprintf(fid,'%c',' ... ');
%          fprintf(fid,'%c\n',' '); 
%     end
%     fprintf(fid,'%c',' ];');
%      fprintf(fid,'%c\n',' '); 
     fclose(fid);
end


