

%---------------------------
%discrete event simulation
%the time is counted in microseconds 
%1 second=1000  milliseconds=10^6 microseconds
%6-node ring network
%OCS
%---------------------------
clear all;
format long;
propagation_speed=3*1e8/1e6;
%propagation_speed=1e20;
switching_delay=0; %usually smaller than 1, so ignore
%offset_time=10; %micorseconds
packet_length=1250*8; %bits
%packet_length=1250;
%average burst length=2.5MB
packet_no_ave=250;
transmission_speed=10*1e9/1e6; %bit/micros

Simulation=1e6;
node=6;
L=6;
OD_no=6;
C=50;
%OD_path=zeros(30,7);
OD_path=[ 1 2 3 0 0 0 0;
     2 3 4 0 0 0 0; 
     3 4 5 0 0 0 0; 
    4 5 6 0 0 0 0; 
     5 6 1 0 0 0 0; 
    6 1 2 0 0 0 0];
link_length=[2*1e5  2*1e5  2*1e5  2*1e5  2*1e5  2*1e5]*5; %the length of each link

Traffic=[ 0.045 0.05 0.06 0.07 0.08 0.1 0.12 0.14 0.2 0.25 0.3]/41;   % offered load to each SD pair, please put the same number in the brackets as in the OBS programs and keep "/41" 

total_block=zeros(1,length(Traffic));
U=zeros(1,length(Traffic));
goodput=zeros(1,length(Traffic));
EU=zeros(1,length(Lambda));
for traf=1:length(Traffic)
    lambda=ones(1,OD_no)*Traffic(traf);  %busrts/micosecond
    
    %propagation_daley_link=link_length./propagation_speed;
    buffer=1;
    link_use=zeros(L,C,1+buffer,4);%layer-1 1-occupy or not; 2-OD_pair; 3-finish time; 4-burst length (no. of packets);
    %layer-2 1-waiting or not;
    %2-OD_pair; 3-hop no.; 4 -min start time;
    %5-max leave time 6-reservation_no 7-burst length (no. of packets) ;
    buffer2=40000;
    reservation_queque=zeros(OD_no,buffer2,5);%1-occupy or not 2-next hop no 3 next hop arrival time 4-reservation_no 5-burst length (no. of packets)
    
    block=zeros(1,OD_no);
    departure=zeros(1,OD_no);
    traffic=lambda*(packet_length*packet_no_ave/transmission_speed+3*link_length(1)/propagation_speed);
    link_block=zeros(1,L);
    link_departure=zeros(1,L);
    OD_arrival=zeros(1,OD_no);
    link_OD_departure=zeros(OD_no,L);
    good_calls=zeros(Simulation,3); %1-OD number, 2-arrival time 3-finish time 
    
    arrivelIntervalTime_control(1:Simulation) = exprnd(1/(sum(lambda)),[1,Simulation]);  % ariival of the control packets, follow possion distribution
    nextNewArrivalTime=arrivelIntervalTime_control(1);
    rd=rand();
    part_arrival=lambda(1);
    finish=0;
    count=1;
    while (finish==0)
        if rd<part_arrival/sum(lambda)
            OD_pair=count;
            finish=1;
        else
            count=count+1;
            part_arrival=part_arrival+lambda(count);
        end
    end
    packet_no=floor(exprnd(packet_no_ave,1));
    path_hop=length(find(OD_path(OD_pair,:)>0));  %find the length of the path;
    path_length=3*link_length(1);
    % calculate the happen time of the next event of different kinds
    
    nextBurstEvent_finish=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length/propagation_speed;  %the time of the call finish serving in this hop
    %record in the table
    for i=1:3
        link_use(OD_path(OD_pair,i),1,1,:)=[1 OD_pair nextBurstEvent_finish packet_no ];
    end
    departure(OD_pair)=departure(OD_pair)+packet_no;
    state_probability=zeros(L,C+1);
    good_calls(1,1)=OD_pair;
    good_calls(1,2)=nextNewArrivalTime;
    good_calls(1,3)=nextBurstEvent_finish;
    
    good_call_count=1;   
    arrival=1;
    nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
    while arrival<Simulation-1
        
            %a new control packet finish reserve the resource ( reserving resources ), a new call comes into the network
            %generate the OD no, path length of the new control packet and the arrival time of the new burst
            
            if arrival>5000
                for iii=1:L
                    xx=link_use(iii,:,1,3)>nextNewArrivalTime;
                    x=sum(xx);
                    state_probability(iii,x+1)=state_probability(iii,x+1)+1;
                end
            end
            
            rd=rand();
            part_arrival=lambda(1);
            finish=0;
            count=1;
            while (finish==0)
                if rd<part_arrival/sum(lambda)
                    OD_pair=count;
                    finish=1;
                else
                    count=count+1;
                    part_arrival=part_arrival+lambda(count);
                end
            end
            packet_no=floor(exprnd(packet_no_ave,1)); %generate the number of packets of the burs
            path_hop=length(find(OD_path(OD_pair,:)>0)); 
            path_length=3*link_length(1);
            call_finish_time=nextNewArrivalTime+packet_no*packet_length/transmission_speed+path_length/propagation_speed;
          
            
            OD_arrival(OD_pair)=OD_arrival(OD_pair)+packet_no;
            
            %find free path
            occupy=zeros(path_hop,C);
            isFree_channel=zeros(1,path_hop);
            for i=1:path_hop
                occupy(i,:)=link_use(OD_path(OD_pair,i),:,1,3)<nextNewArrivalTime;
                if sum(occupy(i,:))>0
                    isFree_channel(i)=1;
                else
                    isFree_channel(i)=0;
                end
            end
            if sum(isFree_channel)<3
                %no free slots, block the reservation
                block(OD_pair)=block(OD_pair)+packet_no;
                %link_block(OD_path(OD_pair,1))=link_block(OD_path(OD_pair,1))+packet_no;
                
            else
                %free time slots, random choose one to fit
                for i=1:3
                    isFree=find(occupy(i,:)==1);
                	channel=isFree(floor(rand()*length(isFree)+1));  %random select a free channel
                    link_use(OD_path(OD_pair,i),channel,1,:)=[1 OD_pair call_finish_time packet_no];
                end
                good_call_count=good_call_count+1;
                good_calls(good_call_count,1)=OD_pair;
                good_calls(good_call_count,2)=nextNewArrivalTime;
                good_calls(good_call_count,3)=call_finish_time;
                departure(OD_pair)=departure(OD_pair)+packet_no;
            end
            arrival=arrival+1;
            nextNewArrivalTime=nextNewArrivalTime+arrivelIntervalTime_control(arrival+1);
    end

    total_block(traf)=sum(block./(block+departure))/6;
    
    
    
    utilization=zeros(L,1);
    for i=1:L
        state_sum=sum(state_probability(i,:));
        state_probability(i,:)=state_probability(i,:)/state_sum;
        average=0;
        for j=1:C+1
            average=average+state_probability(i,j)*(j-1)/C;
        end
        utilization(i)=utilization(i)+average;
    end
    
    U(traf)=sum(utilization)/L;
    goodput(traf)=sum((1-block./(block+departure)).*traffic(i));
    

    no_good_calls=length(find(good_calls(:,1)>0));
    inspector_interval=exprnd(1.1/(sum(lambda)),[1,Simulation/2]);
    inspector=zeros(1,Simulation/2);
    inspector(1)=1/(sum(lambda))*1000;
    for i=2:Simulation/2
        inspector(i)=inspector(i-1)+inspector_interval(i-1);
    end
    good_utilization_count=zeros(Simulation/2,L);
    
    for i=1:no_good_calls
        
        
            x=min(find(inspector(:)>=good_calls(i,2)));
            y=max(find(inspector(:)<good_calls(i,3)));
            if x<=y
                for j=x:y
                    good_utilization_count(j,OD_path(good_calls(i,1),1))=good_utilization_count(j,OD_path(good_calls(i,1),1))+1;
                    good_utilization_count(j,OD_path(good_calls(i,1),2))=good_utilization_count(j,OD_path(good_calls(i,1),2))+1;
                    good_utilization_count(j,OD_path(good_calls(i,1),3))=good_utilization_count(j,OD_path(good_calls(i,1),3))+1;
                    
                end
            end
            
        
    end
    
    efficient_state_probability=zeros(L,C+1);
    for i=1:L
        for j=1:Simulation/2
            state=good_utilization_count(j,i);
            efficient_state_probability(i,state+1)=efficient_state_probability(i,state+1)+1;
        end
    end
    efficient_utilization=zeros(1,L);
    for i=1:L
        state_sum=sum(efficient_state_probability(i,:));
        efficient_state_probability(i,:)=efficient_state_probability(i,:)/state_sum;
        average=0;
        for j=1:C+1
            average=average+efficient_state_probability(i,j)*(j-1)/C;
        end
        efficient_utilization(i)=efficient_utilization(i)+average; 
    end
    EU(traf)=sum(efficient_utilization)/L;
    
       fid = fopen('OCS_7.txt','wt'); 
    fprintf(fid,'%c','total_block=[ ');
    for k=1:traf 
         p_B=num2str(total_block(k));
        fprintf(fid,'%c',p_B);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
     fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','U=[ ');
    for k=1:traf;
         p_U=num2str(U(k));
        fprintf(fid,'%c',p_U);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',' ];');
    fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','goodput=[ ');
    for k=1:traf 
         p_g=num2str(goodput(k));
        fprintf(fid,'%c',p_g);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',']; ');
    fprintf(fid,'%c\n',' '); 
    fprintf(fid,'%c','EU=[ ');
    for k=1:traf
         p_EU=num2str(EU(k));
        fprintf(fid,'%c',p_EU);  
        fprintf(fid,'%c',' '); 
    end
    fprintf(fid,'%c',']; ');
     fprintf(fid,'%c\n',' ');
     fprintf(fid,'%c\n',' ');
     fclose(fid);
end



